

.code

mAlloc proc nSize:dword
	
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,nSize
	.if eax==0
		invoke MessageBox,NULL,CADD("Memory Allocation Error"),NULL,MB_OK
		invoke PostQuitMessage,NULL
	.endif
	
	ret
mAlloc endp

NewThread proc procoffset:dword
	LOCAL tid:dword
	
	invoke CreateThread,NULL,NULL,procoffset,NULL,NORMAL_PRIORITY_CLASS,addr tid
	invoke CloseHandle,tid
	
	ret
NewThread endp

; 
fRead proc tumpukan:dword,namafile:dword,lpukuran:dword,ukr:dword
  LOCAL hfile:dword
  
 invoke CreateFile,namafile,GENERIC_READ ,FILE_SHARE_READ ,NULL,OPEN_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,NULL
 mov hfile,eax
 invoke ReadFile,hfile,tumpukan,ukr,lpukuran,NULL  
 
 brs:
 invoke CloseHandle,hfile	
 
 ret
fRead endp

;
LoadPicture proc filename:dword
	LOCAL buff[512],hMemDC,hBitmap,mptr,err_code:dword
	LOCAL file_size:dword
	LOCAL bm:BITMAP
	LOCAL xres,yres:dword

	invoke exist,filename
	.if eax!=1
		invoke MessageBox,NULL,filename,CADD("File not found"),MB_OK
		xor eax,eax
		dec eax
		ret
	.endif
	invoke filesize,filename
	mov file_size,eax
	invoke mAlloc,eax
	mov mptr,eax
	invoke fRead,mptr,filename,addr err_code,file_size
	invoke BitmapFromMemory,mptr,file_size
	.if eax==0
		invoke MessageBox,NULL,CADD("Bad Picture Format"),filename,MB_OK
		xor eax,eax
		dec eax
		ret
	.endif
	
	push eax
	invoke GlobalFree,mptr
	pop eax
	
	ret
LoadPicture endp

; 
ShowBitmap proc hDC:dword,hbmp:dword
	LOCAL mdc,oldbmp:dword
	LOCAL bm:BITMAP
	LOCAL yres,sres:dword
	
	invoke CreateCompatibleDC,hDC
	mov mdc,eax
	
	invoke SelectObject,mdc,hbmp
	mov oldbmp,eax
	
	invoke GetObject,hbmp,sizeof BITMAP,addr bm
	
	invoke BitBlt,hDC,0,0,bm.bmWidth,bm.bmHeight,mdc,0,0,SRCCOPY
	
	invoke SelectObject,mdc,oldbmp
	invoke DeleteObject,oldbmp
	invoke DeleteDC,mdc
	
	ret
ShowBitmap endp

fCreateDIB proc hDC:dword,nHorRes:dword,nVertRes:dword,nBits:dword
	LOCAL bih:BITMAPINFOHEADER
	LOCAL pointer_bitmap:dword
	
	mov bih.biSize,sizeof BITMAPINFOHEADER
	push nHorRes
	pop bih.biWidth
	push nVertRes
	pop bih.biHeight
	mov bih.biPlanes,1
	push nBits
	pop bih.biBitCount
	
	mov bih.biCompression,BI_RGB
	mov bih.biSizeImage,0
	mov bih.biXPelsPerMeter,0
	mov bih.biYPelsPerMeter,0
	mov bih.biClrUsed,0
	mov bih.biClrImportant,0
	invoke CreateDIBSection,hDC,addr bih,DIB_RGB_COLORS,addr pointer_bitmap,0,0
	.if eax==0
		invoke MessageBox,NULL,CADD("Error Cannot Create Bitmap"),CADD("Error"),MB_OK
	.endif
	mov edx,pointer_bitmap
	
	ret
fCreateDIB endp